### shell shape indendepency analysis---------------

##Phylogenetic signal analysis-------
require(geiger)
require(phytools)
require(devtools)
require(nlme)
require(qpcR)
require(reshape)
require(calibrate)
setwd("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/phylogenetic analysis/with outgroup/gieger/")
tree_file <- read.tree("Plectostoma_bayestree_07012014.nex")
plot(tree_file,cex=0.5)

shell <- read.csv("Plectostoma_shell_form_ex_outgroup.csv", row.names=1)
str(shell)

taxa_only_in_tree <- setdiff(tree_file$tip.label,rownames(shell))
taxa_only_in_tree

taxa_only_in_char <- setdiff(rownames(shell),tree_file$tip.label)
taxa_only_in_char

tree_file <- drop.tip(tree_file,taxa_only_in_tree)
tree_file

patristic_distance_matrix <- cophenetic(tree_file)
write.table(patristic_distance_matrix, file = "patristic_distancematrix.csv", sep = ",")
TABLE <- melt(patristic_distance_matrix)[melt(upper.tri(patristic_distance_matrix))$value,]
write.table(TABLE, file = "TABLE.csv", sep = ",")


sorted_shell_according_tree_order <- shell[tree_file$tip.label,]

sorted_shell_Apex.form <- sorted_shell_according_tree_order[,1]
names(sorted_shell_Apex.form) <- row.names(shell)

sorted_shell_Apical.spire.form <- sorted_shell_according_tree_order[,2]
names(sorted_shell_Apical.spire.form) <- row.names(shell)

sorted_shell_Basal.spire.form <- sorted_shell_according_tree_order[,3]
names(sorted_shell_Basal.spire.form) <- row.names(shell)

sorted_shell_Tuba.form  <- sorted_shell_according_tree_order[,4]
names(sorted_shell_Tuba.form) <- row.names(shell)

sorted_shell_Aperture.view  <- sorted_shell_according_tree_order[,5]
names(sorted_shell_Aperture.view ) <- row.names(shell)

sorted_shell_Rib.shape  <- sorted_shell_according_tree_order[,8]
names(sorted_shell_Rib.shape ) <- row.names(shell)

sorted_shell_Rib.thickness   <- sorted_shell_according_tree_order[,9]
names(sorted_shell_Rib.thickness  ) <- row.names(shell)

sorted_shell_size   <- sorted_shell_according_tree_order[,10]
names(sorted_shell_size  ) <- row.names(shell)

sorted_shell_distribution  <- sorted_shell_according_tree_order[,6]
names(sorted_shell_distribution) <- row.names(shell)

par(mar=c(0.25,0.25, 0.01, 0.5),mfcol=c(3, 3))
plot(tree_file, show.tip.label=FALSE)
Apex.form_colour_legend<-character(length(sorted_shell_Apex.form))
Apex.form_colour_legend[sorted_shell_Apex.form=="2 - moderately convex"]<-"yellow"
Apex.form_colour_legend[sorted_shell_Apex.form=="3 - distinctly convex"]<-"blue"
tiplabels(tree_file$tip.label, col=Apex.form_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Apical.spire.form_colour_legend<-character(length(sorted_shell_Apical.spire.form))
Apical.spire.form_colour_legend[sorted_shell_Apical.spire.form=="1 - depressed"]<-"red"
Apical.spire.form_colour_legend[sorted_shell_Apical.spire.form=="2 - equilateral"]<-"yellow"
Apical.spire.form_colour_legend[sorted_shell_Apical.spire.form=="3 - oblong"]<-"blue"
tiplabels(tree_file$tip.label, col=Apical.spire.form_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Basal.spire.form_colour_legend<-character(length(sorted_shell_Basal.spire.form))
Basal.spire.form_colour_legend[sorted_shell_Basal.spire.form=="1 - ellipsoid"]<-"red"
Basal.spire.form_colour_legend[sorted_shell_Basal.spire.form=="2 - ovoid"]<-"yellow"
Basal.spire.form_colour_legend[sorted_shell_Basal.spire.form=="3 - conical"]<-"blue"
tiplabels(tree_file$tip.label, col=Basal.spire.form_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Tuba.form_colour_legend<-character(length(sorted_shell_Tuba.form))
Tuba.form_colour_legend[sorted_shell_Tuba.form=="1 - regular"]<-"red"
Tuba.form_colour_legend[sorted_shell_Tuba.form=="2 - distort"]<-"yellow"
Tuba.form_colour_legend[sorted_shell_Tuba.form=="3 - twist"]<-"blue"
tiplabels(tree_file$tip.label, col=Tuba.form_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Aperture.view_colour_legend<-character(length(sorted_shell_Aperture.view))
Aperture.view_colour_legend[sorted_shell_Aperture.view=="1 - front"]<-"red"
Aperture.view_colour_legend[sorted_shell_Aperture.view=="2 - left"]<-"yellow"
Aperture.view_colour_legend[sorted_shell_Aperture.view=="3 - back"]<-"blue"
Aperture.view_colour_legend[sorted_shell_Aperture.view=="4 - right"]<-"green"
tiplabels(tree_file$tip.label, col=Aperture.view_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Rib.shape_colour_legend<-character(length(sorted_shell_Rib.shape))
Rib.shape_colour_legend[sorted_shell_Rib.shape=="1 - straight"]<-"red"
Rib.shape_colour_legend[sorted_shell_Rib.shape=="2 - slightly curved"]<-"yellow"
Rib.shape_colour_legend[sorted_shell_Rib.shape=="3 - single humped"]<-"blue"
Rib.shape_colour_legend[sorted_shell_Rib.shape=="4 - single looped"]<-"green"
tiplabels(tree_file$tip.label, col=Rib.shape_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
Rib.thickness_colour_legend<-character(length(sorted_shell_Rib.thickness))
Rib.thickness_colour_legend[sorted_shell_Rib.thickness=="1 - thick"]<-"red"
Rib.thickness_colour_legend[sorted_shell_Rib.thickness=="2 - thin"]<-"yellow"
tiplabels(tree_file$tip.label, col=Rib.thickness_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

plot(tree_file, show.tip.label=FALSE)
distribution_colour_legend<-character(length(sorted_shell_distribution))
distribution_colour_legend[sorted_shell_distribution=="Borneo"]<-"red"
distribution_colour_legend[sorted_shell_distribution=="Non-Borneo"]<-"yellow"
tiplabels(tree_file$tip.label, col=distribution_colour_legend, frame="none", bg="white", adj=-0.01, cex=0.7)

par(mar=c(1,2, 0.01, 0.5), mfcol=c(1, 1))
plot(tree_file, x.lim=c(0,0.6), no.margin=FALSE, root.edge=FALSE, cex=0.7, font=4, label.offset=0.025, edge.width=3)
add.scale.bar(x=0.25, y =0.5, cex=0.7, lwd = 3)
points(rep(0.33, 21), 1:21, col ="black", bg= Apex.form_colour_legend, pch = 22, cex = 3)
points(rep(0.355, 21), 1:21, col ="black", bg=  Apical.spire.form_colour_legend, pch = 22, cex = 3)
points(rep(0.38, 21), 1:21, col ="black", bg=  Basal.spire.form_colour_legend, pch = 22, cex = 3)
points(rep(0.405, 21), 1:21, col ="black", bg=  Tuba.form_colour_legend, pch = 22, cex = 3)
points(rep(0.43, 21), 1:21, col ="black", bg=  Aperture.view_colour_legend, pch = 22, cex = 3)
points(rep(0.485, 21), 1:21, col ="black", bg=  Rib.shape_colour_legend, pch = 21, cex = 3)
points(rep(0.51, 21), 1:21, col ="black", bg=  Rib.thickness_colour_legend, pch = 21, cex = 3)
points(rep(0.565, 21), 1:21, col ="black", bg=  distribution_colour_legend, pch = 23, cex = 3)
nodelabels("0.69", 40, frame = "r", bg = "white", cex=0.65)
nodelabels("0.92", 23, frame = "r", bg = "white", cex=0.65)
nodelabels("1.0", 22, frame = "r", bg = "grey", cex=0.7, font=2)


#to be changed
#is.ultrametric(tree_file)
#addTip<-max(vcv(tree_file))-diag(vcv(tree_file))
#tree_file$edge.length[tree_file$edge[,2]<=length(tree_file$tip)]<- tree_file$edge.length[tree_file$edge[,2]<=length(tree_file$tip)]+addTip
#tree_file<-di2multi(tree_file)
#is.ultrametric(tree_file)



# (2) Testing for phylogenetic signal using Pagel's lambda with the fitDiscrete function in geiger.
# convert phylogram to chronogram - using Sanderson's semi-parametric penalized likelihood approach
tree_file <- chronopl(tree_file, lambda=0.1) 
plot(tree_file)

lambda_0_hypothesis_tree <- transform(tree_file,"lambda", 0)
plot(tree_file)
plot(lambda_0_hypothesis_tree)

Apex.form_lambda <- fitDiscrete(tree_file, sorted_shell_Apex.form, transform="lambda")
Apex.form_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Apex.form, transform="lambda")
Apex.form_lambda_chisq <- 1-pchisq((-2*(Apex.form_lambda_0$opt$lnL))+(2*(Apex.form_lambda$opt$lnL)),1)
Apex.form_lambda$opt$lambda
Apex.form_lambda$opt$lnL
Apex.form_lambda_0$opt$lnL
Apex.form_lambda_chisq

Apical.spire.form_lambda <- fitDiscrete(tree_file, sorted_shell_Apical.spire.form, transform="lambda")
Apical.spire.form_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Apical.spire.form, transform="lambda")
Apical.spire.form_lambda_chisq <- 1-pchisq((-2*(Apical.spire.form_lambda_0$opt$lnL))+(2*(Apical.spire.form_lambda$opt$lnL)),1)
Apical.spire.form_lambda$opt$lambda
Apical.spire.form_lambda$opt$lnL
Apical.spire.form_lambda_0$opt$lnL
Apical.spire.form_lambda_chisq

Basal.spire.form_lambda <- fitDiscrete(tree_file, sorted_shell_Basal.spire.form, transform="lambda")
Basal.spire.form_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Basal.spire.form, transform="lambda")
Basal.spire.form_lambda_chisq <-  1-pchisq((-2*(Basal.spire.form_lambda_0$opt$lnL))+(2*(Basal.spire.form_lambda$opt$lnL)),1)
Basal.spire.form_lambda$opt$lambda
Basal.spire.form_lambda$opt$lnL
Basal.spire.form_lambda_0$opt$lnL
Basal.spire.form_lambda_chisq

Tuba.form_lambda <- fitDiscrete(tree_file, sorted_shell_Tuba.form, transform="lambda")
Tuba.form_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Tuba.form, transform="lambda")
Tuba.form_lambda_chisq <- 1-pchisq((-2*(Tuba.form_lambda_0$opt$lnL))+(2*(Tuba.form_lambda$opt$lnL)),1)
Tuba.form_lambda$opt$lambda
Tuba.form_lambda$opt$lnL
Tuba.form_lambda_0$opt$lnL
Tuba.form_lambda_chisq

Aperture.view_lambda <- fitDiscrete(tree_file, sorted_shell_Aperture.view,transform="lambda")
Aperture.view_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Aperture.view, transform="lambda")
Aperture.view_lambda_chisq <- 1-pchisq((-2*(Aperture.view_lambda_0$opt$lnL))+(2*(Aperture.view_lambda$opt$lnL)),1)
Aperture.view_lambda$opt$lambda
Aperture.view_lambda$opt$lnL
Aperture.view_lambda_0$opt$lnL
Aperture.view_lambda_chisq

Rib.shape_lambda <- fitDiscrete(tree_file, sorted_shell_Rib.shape,transform="lambda")
Rib.shape_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Rib.shape, transform="lambda")
Rib.shape_lambda_chisq <- 1-pchisq((-2*(Rib.shape_lambda_0$opt$lnL))+(2*(Rib.shape_lambda$opt$lnL)),1)
Rib.shape_lambda$opt$lambda
Rib.shape_lambda$opt$lnL
Rib.shape_lambda_0$opt$lnL
Rib.shape_lambda_chisq

Rib.thickness_lambda <- fitDiscrete(tree_file, sorted_shell_Rib.thickness,transform="lambda")
Rib.thickness_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_Rib.thickness, transform="lambda")
Rib.thickness_lambda_chisq <- 1-pchisq((-2*(Rib.thickness_lambda_0$opt$lnL))+(2*(Rib.thickness_lambda$opt$lnL)),1)
Rib.thickness_lambda$opt$lambda
Rib.thickness_lambda$opt$lnL
Rib.thickness_lambda_0$opt$lnL
Rib.thickness_lambda_chisq

size_lambda <- fitContinuous(tree_file, sorted_shell_size,model="lambda")
size_lambda_0 <- fitContinuous(lambda_0_hypothesis_tree, sorted_shell_size, model="lambda")
size_lambda_chisq <- 1-pchisq((-2*(size_lambda_0$opt$lnL))+(2*(size_lambda$opt$lnL)),1)
size_lambda$opt$lambda
size_lambda$opt$lnL
size_lambda_0$opt$lnL
size_lambda_chisq


distribution_lambda <- fitDiscrete(tree_file, sorted_shell_distribution,transform="lambda")
distribution_lambda_0 <- fitDiscrete(lambda_0_hypothesis_tree, sorted_shell_distribution, transform="lambda")
distribution_lambda_chisq <- 1-pchisq((-2*(distribution_lambda_0$opt$lnL))+(2*(distribution_lambda$opt$lnL)),1)
distribution_lambda$opt$lambda
distribution_lambda$opt$lnL
distribution_lambda_0$opt$lnL
distribution_lambda_chisq

phylosig(tree_file,sorted_shell_size,test=TRUE)
phylosig(tree_file,sorted_shell_size,method="lambda",test=TRUE)
phylosig(tree_file,sorted_shell_size,method="K",test=TRUE)


###Ancestral character estimation----
require(ape)
#par(mar=c(0.01,0.01, 0.01, 0.01),mfrow=c(3, 3))
par(mar=c(0.25,0.25, 0.01, 0.5),mfcol=c(1, 1))
ACE_apex <- ace(sorted_shell_Apex.form, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_apex$lik.anc, cex=1, piecol = c("yellow","blue"))

ACE_apical_apire <- ace(sorted_shell_Apical.spire.form, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_apical_apire$lik.anc, cex=1, piecol = c("red","yellow","blue"))

ACE_basal_apire <- ace(sorted_shell_Basal.spire.form, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_basal_apire$lik.anc, cex=1, piecol = c("red","yellow","blue"))

ACE_tuba <- ace(sorted_shell_Tuba.form, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_tuba$lik.anc, cex=1, piecol = c("red","yellow","blue"))

ACE_aperture <- ace(sorted_shell_Aperture.view, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_aperture$lik.anc, cex=1, piecol = c("red","yellow","blue","green"))

ACE_size <- ace(sorted_shell_size, tree_file, type="continuous", method="ML")
plot(tree_file)
ACE_size
nodelabels(pch = 21, col = "black", bg= "purple", cex=((ACE_size$ace/1.5)))

ACE_rib_shape <- ace(sorted_shell_Rib.shape, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_rib_shape$lik.anc, cex=1, piecol = c("red","yellow","blue","green"))

ACE_rib_thickness <- ace(sorted_shell_Rib.thickness, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_rib_thickness$lik.anc, cex=1, piecol = c("red","yellow","blue","green"))

ACE_distribution <- ace(sorted_shell_distribution, tree_file, type="discrete")
plot(tree_file)
nodelabels(pie=ACE_distribution$lik.anc, cex=1, piecol = c("red","yellow","blue","green"))


##aperture ontogeny profile -----
christae_bor_5572_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_christae_bor_5572_surface_circle_no_peristome.001 NEFA.csv")
crassipupa_bor_5512_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_crassipupa_5512_surface_circle_no_peristome.001 NEFA.csv")
laidlawi_zma_136014_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_laidlawi_surface_circle_no_peristome.001 NEFA.csv")
sinyumensis_bor_5537_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/sinyumensis17122013 SurfCircle.001 NEFA.csv")
tenggekensis_bor_5650_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell tenggekensis_bor_5650.004 NEFA.csv")
retrovertens_bor_5559_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/retrovertens21112013 SurfCircle.001 NEFA.csv")
siphonostomum_bor_5521_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/siphonotomum23112013 SurfCircle.001 NEFA.csv")
senex_bor_5603_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/senex07122013 Plectostoma senex BOR 5603 retopo mesh NEFA.csv")
davisoni_bor_5508_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell davisoni_bor_5508.004 NEFA.csv")
grandispinosum_bor_5567_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/grandispinosum_BOR 5567_03012014 NEFA.csv")
concinnum_kampung_NEFA <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell concinnum_kampung.004 NEFA.csv")

christae_bor_5572_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_christae_bor_5572_surface_circle_no_peristome.001 perimeter.csv")
crassipupa_bor_5512_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_crassipupa_5512_surface_circle_no_peristome.001 perimeter.csv")
laidlawi_zma_136014_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_laidlawi_surface_circle_no_peristome.001 perimeter.csv")
sinyumensis_bor_5537_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/sinyumensis17122013 SurfCircle.001 perimeter.csv")
tenggekensis_bor_5650_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell tenggekensis_bor_5650.004 perimeter.csv")
retrovertens_bor_5559_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/retrovertens21112013 SurfCircle.001 perimeter.csv")
siphonostomum_bor_5521_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/siphonotomum23112013 SurfCircle.001 perimeter.csv")
senex_bor_5603_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/senex07122013 Plectostoma senex BOR 5603 retopo mesh perimeter.csv")
davisoni_bor_5508_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell davisoni_bor_5508.004 perimeter.csv")
grandispinosum_bor_5567_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/grandispinosum_BOR 5567_03012014 perimeter.csv")
concinnum_kampung_perimeter <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell concinnum_kampung.004 perimeter.csv")

christae_bor_5572_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_christae_bor_5572_surface_circle_no_peristome.001_q70.csv")
crassipupa_bor_5512_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_crassipupa_5512_surface_circle_no_peristome.001_q50.csv")
laidlawi_zma_136014_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/A practical guide to morphological analysis of 3D model/To be submit to PeerJ/all morphometric for 4 species/all 4 shell Retopo_laidlawi_surface_circle_no_peristome.001_q70.csv")
sinyumensis_bor_5537_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/sinyumensis17122013 SurfCircle.001_q90.csv")
tenggekensis_bor_5650_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell tenggekensis_bor_5650.004_q50.csv")
retrovertens_bor_5559_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/retrovertens21112013 SurfCircle.001_q99.csv")
siphonostomum_bor_5521_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/siphonotomum23112013 SurfCircle.001_q80.csv")
senex_bor_5603_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/senex07122013 Plectostoma senex BOR 5603 retopo mesh_q96.csv")
davisoni_bor_5508_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell davisoni_bor_5508.004_q50.csv")
grandispinosum_bor_5567_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/grandispinosum_BOR 5567_03012014_q60.csv")
concinnum_kampung_torsion_curvature_ontogenyaxis <- read.csv("C:/Liew Thor Seng/PhD thesis/Molecular phylogeny and evolution of Plectostoma/3D model/all 11 retopo shell concinnum_kampung.004_q50.csv")

#
# Merge files      
#
all_morphometric_christae_bor_5572_temp1 <- merge(christae_bor_5572_NEFA,christae_bor_5572_perimeter,by="aperture")
all_morphometric_christae_bor_5572_temp2 <- merge(christae_bor_5572_torsion_curvature_ontogenyaxis,all_morphometric_christae_bor_5572_temp1,by="aperture")
label <- rep('christae', 760)
all_morphometric_christae_bor_5572 <- cbind(all_morphometric_christae_bor_5572_temp2,label)

all_morphometric_crassipupa_bor_5512_temp1 <- merge(crassipupa_bor_5512_NEFA,crassipupa_bor_5512_perimeter,by="aperture")
all_morphometric_crassipupa_bor_5512_temp2 <- merge(crassipupa_bor_5512_torsion_curvature_ontogenyaxis,all_morphometric_crassipupa_bor_5512_temp1,by="aperture")
label <- rep('crassipupa', 576)
all_morphometric_crassipupa_bor_5512 <- cbind(all_morphometric_crassipupa_bor_5512_temp2,label)

all_morphometric_laidlawi_zma_136014_temp1 <- merge(laidlawi_zma_136014_NEFA,laidlawi_zma_136014_perimeter,by="aperture")
all_morphometric_laidlawi_zma_136014_temp2 <- merge(laidlawi_zma_136014_torsion_curvature_ontogenyaxis,all_morphometric_laidlawi_zma_136014_temp1,by="aperture")
label <- rep('laidlawi', 760)
all_morphometric_laidlawi_zma_136014 <- cbind(all_morphometric_laidlawi_zma_136014_temp2,label)

all_morphometric_sinyumensis_bor_5537_temp1 <- merge(sinyumensis_bor_5537_NEFA,sinyumensis_bor_5537_perimeter,by="aperture")
all_morphometric_sinyumensis_bor_5537_temp2 <- merge(sinyumensis_bor_5537_torsion_curvature_ontogenyaxis,all_morphometric_sinyumensis_bor_5537_temp1,by="aperture")
label <- rep('sinyumensis', 952)
all_morphometric_sinyumensis_bor_5537 <- cbind(all_morphometric_sinyumensis_bor_5537_temp2,label)

all_morphometric_tenggekensis_bor_5650_temp1 <- merge(tenggekensis_bor_5650_NEFA,tenggekensis_bor_5650_perimeter,by="aperture")
all_morphometric_tenggekensis_bor_5650_temp2 <- merge(tenggekensis_bor_5650_torsion_curvature_ontogenyaxis,all_morphometric_tenggekensis_bor_5650_temp1,by="aperture")
label <- rep('tenggekensis', 980)
all_morphometric_tenggekensis_bor_5650 <- cbind(all_morphometric_tenggekensis_bor_5650_temp2,label)

all_morphometric_retrovertens_bor_5559_temp1 <- merge(retrovertens_bor_5559_NEFA,retrovertens_bor_5559_perimeter,by="aperture")
all_morphometric_retrovertens_bor_5559_temp2 <- merge(retrovertens_bor_5559_torsion_curvature_ontogenyaxis,all_morphometric_retrovertens_bor_5559_temp1,by="aperture")
label <- rep('retrovertens', 992)
all_morphometric_retrovertens_bor_5559 <- cbind(all_morphometric_retrovertens_bor_5559_temp2,label)

all_morphometric_siphonostomum_bor_5521_temp1 <- merge(siphonostomum_bor_5521_NEFA,siphonostomum_bor_5521_perimeter,by="aperture")
all_morphometric_siphonostomum_bor_5521_temp2 <- merge(siphonostomum_bor_5521_torsion_curvature_ontogenyaxis,all_morphometric_siphonostomum_bor_5521_temp1,by="aperture")
label <- rep('siphonostomum', 856)
all_morphometric_siphonostomum_bor_5521 <- cbind(all_morphometric_siphonostomum_bor_5521_temp2,label)

all_morphometric_senex_bor_5603_temp1 <- merge(senex_bor_5603_NEFA,senex_bor_5603_perimeter,by="aperture")
all_morphometric_senex_bor_5603_temp2 <- merge(senex_bor_5603_torsion_curvature_ontogenyaxis,all_morphometric_senex_bor_5603_temp1,by="aperture")
label <- rep('senex', 968)
all_morphometric_senex_bor_5603 <- cbind(all_morphometric_senex_bor_5603_temp2,label)


all_morphometric_davisoni_bor_5508_temp1 <- merge(davisoni_bor_5508_NEFA,davisoni_bor_5508_perimeter,by="aperture")
all_morphometric_davisoni_bor_5508_temp2 <- merge(davisoni_bor_5508_torsion_curvature_ontogenyaxis,all_morphometric_davisoni_bor_5508_temp1,by="aperture")
label <- rep('davisoni', 936)
all_morphometric_davisoni_bor_5508 <- cbind(all_morphometric_davisoni_bor_5508_temp2,label)

all_morphometric_grandispinosum_bor_5567_temp1 <- merge(grandispinosum_bor_5567_NEFA,grandispinosum_bor_5567_perimeter,by="aperture")
all_morphometric_grandispinosum_bor_5567_temp2 <- merge(grandispinosum_bor_5567_torsion_curvature_ontogenyaxis,all_morphometric_grandispinosum_bor_5567_temp1,by="aperture")
label <- rep('grandispinosum', 660)
all_morphometric_grandispinosum_bor_5567 <- cbind(all_morphometric_grandispinosum_bor_5567_temp2,label)

all_morphometric_concinnum_kampung_temp1 <- merge(concinnum_kampung_NEFA,concinnum_kampung_perimeter,by="aperture")
all_morphometric_concinnum_kampung_temp2 <- merge(concinnum_kampung_torsion_curvature_ontogenyaxis,all_morphometric_concinnum_kampung_temp1,by="aperture")
label <- rep('concinnum', 963)
all_morphometric_concinnum_kampung <- cbind(all_morphometric_concinnum_kampung_temp2,label)

combined_all_morphometric_data_of_all_shells <- rbind(all_morphometric_christae_bor_5572, all_morphometric_crassipupa_bor_5512,all_morphometric_laidlawi_zma_136014,all_morphometric_sinyumensis_bor_5537,all_morphometric_tenggekensis_bor_5650,all_morphometric_retrovertens_bor_5559,all_morphometric_siphonostomum_bor_5521,all_morphometric_senex_bor_5603,all_morphometric_davisoni_bor_5508,all_morphometric_grandispinosum_bor_5567,all_morphometric_concinnum_kampung)#,all_morphometric_vermiculum_rapat,all_morphometric_chris_ob_bor_5572,all_morphometric_chris_de_bor_5572) 
str(combined_all_morphometric_data_of_all_shells)
summary(combined_all_morphometric_data_of_all_shells)



## B) Procedure 6:                                      ## 
##    Principal component analysis on EFA coeefficient. 
species <- combined_all_morphometric_data_of_all_shells[,48]
ontogeny_axis <- combined_all_morphometric_data_of_all_shells[,3]
aperture_size <- combined_all_morphometric_data_of_all_shells[,47]
NEFA_cooefficient_Of_all_shells <- combined_all_morphometric_data_of_all_shells[,12:41]
str(NEFA_cooefficient_Of_all_shells)

pca <- prcomp(NEFA_cooefficient_Of_all_shells)
#plot(pca)
summary(pca)
rot <- pca$r
round(rot*100)
pca_scores <- pca$x


Final_data_output <- 
  cbind((combined_all_morphometric_data_of_all_shells[,1:3]),
        as.numeric(format((combined_all_morphometric_data_of_all_shells[,9]), digit = 2)),
        as.numeric(format((combined_all_morphometric_data_of_all_shells[,10]), digit = 2)),
        (pca_scores[,1:3]),
        (combined_all_morphometric_data_of_all_shells[,47:48])
  )

colnames(Final_data_output) <- c(colnames(Final_data_output)[1:3],"curvature","torsion",colnames(Final_data_output)[6:10])
str(Final_data_output)

write.table(Final_data_output, file = "Final_data_output.csv", sep = ",")
getwd()



##Shell ontogenetic morphospace: shell size (volume), aperture size, ontogeny aixs length----
shell_volume <- c(2.140,0.889,2.370,1.481,1.420,2.780,1.157,3.116,1.713,7.664,1.864)

ontogeny_axis_length <- c(
  max(christae_bor_5572_torsion_curvature_ontogenyaxis[,3]),
  max(crassipupa_bor_5512_torsion_curvature_ontogenyaxis[,3]),  
  max(laidlawi_zma_136014_torsion_curvature_ontogenyaxis[,3]),  
  max(sinyumensis_bor_5537_torsion_curvature_ontogenyaxis[,3]), 
  max(tenggekensis_bor_5650_torsion_curvature_ontogenyaxis[,3]),
  max(retrovertens_bor_5559_torsion_curvature_ontogenyaxis[,3]),  
  max(siphonostomum_bor_5521_torsion_curvature_ontogenyaxis[,3]), 
  max(senex_bor_5603_torsion_curvature_ontogenyaxis[,3]),  
  max(davisoni_bor_5508_torsion_curvature_ontogenyaxis[,3]), 
  max(grandispinosum_bor_5567_torsion_curvature_ontogenyaxis[,3]),  
  max(concinnum_kampung_torsion_curvature_ontogenyaxis[,3])
)


label <- c("christae_bor_5572",
           "crassipupa_bor_5512",  
           "laidlawi_zma_136014",  
           "sinyumensis_bor_5537", 
           "tenggekensis_bor_5650",
           "retrovertens_bor_5559",  
           "siphonostomum_bor_5521", 
           "senex_bor_5603",  
           "davisoni_bor_5508", 
           "grandispinosum_bor_5567",  
           "concinnum_kampung")


shell_volume_and_ontogeny_axis_length <- cbind(ontogeny_axis_length,shell_volume)
rownames(shell_volume_and_ontogeny_axis_length) <- label
par(mar=c(2,2,2,2),mfcol=c(1, 1))
plot(shell_volume_and_ontogeny_axis_length[,1],
     shell_volume_and_ontogeny_axis_length[,2],
     pch = 21, cex = 2,
     bg=c("red","yellow","blue","dodgerblue","darkgreen","black","grey","purple", "green", "darkorange","darkred")
)
plot(log(shell_volume_and_ontogeny_axis_length[,1]),
     log(shell_volume_and_ontogeny_axis_length[,2]),
     pch = 21, cex = 2,
     bg=c("red","yellow","blue","dodgerblue","darkgreen","black","grey","purple", "green", "darkorange","darkred"),
     xlim = c(2.2,3.2), ylim = c(-0.5,2.5)
)
shapiro.test(log(shell_volume_and_ontogeny_axis_length[,1]))
shapiro.test(log(shell_volume_and_ontogeny_axis_length[,2]))
cor.test(log(shell_volume_and_ontogeny_axis_length[,1]),log(shell_volume_and_ontogeny_axis_length[,2]),method = "pearson")

standardised_curvature <- (Final_data_output$curvature*Final_data_output$perimeter)
standardised_torsion <- (Final_data_output$torsion*Final_data_output$perimeter)


shell_volume_list=c(rep(2.140,760),rep(0.889,576), rep(2.370,760), rep(1.481,952), rep(1.420,980),rep(2.780,992),rep(1.157,856),rep(3.116,968), rep(1.713,936), rep(7.664,660), rep(1.864,963))

standardised_ontogeny_axis <- c(
  (rev(christae_bor_5572_torsion_curvature_ontogenyaxis[,3])/max(christae_bor_5572_torsion_curvature_ontogenyaxis[,3])),
  (rev(crassipupa_bor_5512_torsion_curvature_ontogenyaxis[,3])/max(crassipupa_bor_5512_torsion_curvature_ontogenyaxis[,3])),
  (rev(laidlawi_zma_136014_torsion_curvature_ontogenyaxis[,3])/max(laidlawi_zma_136014_torsion_curvature_ontogenyaxis[,3])), 
  (sinyumensis_bor_5537_torsion_curvature_ontogenyaxis[,3])/max(sinyumensis_bor_5537_torsion_curvature_ontogenyaxis[,3]), 
  (tenggekensis_bor_5650_torsion_curvature_ontogenyaxis[,3])/max(tenggekensis_bor_5650_torsion_curvature_ontogenyaxis[,3]), 
  (retrovertens_bor_5559_torsion_curvature_ontogenyaxis[,3])/max(retrovertens_bor_5559_torsion_curvature_ontogenyaxis[,3]), 
  (siphonostomum_bor_5521_torsion_curvature_ontogenyaxis[,3])/max(siphonostomum_bor_5521_torsion_curvature_ontogenyaxis[,3]),
  (senex_bor_5603_torsion_curvature_ontogenyaxis[,3])/max(senex_bor_5603_torsion_curvature_ontogenyaxis[,3]), 
  (davisoni_bor_5508_torsion_curvature_ontogenyaxis[,3])/max(davisoni_bor_5508_torsion_curvature_ontogenyaxis[,3]), 
  (rev(grandispinosum_bor_5567_torsion_curvature_ontogenyaxis[,3])/max(grandispinosum_bor_5567_torsion_curvature_ontogenyaxis[,3])),
  (concinnum_kampung_torsion_curvature_ontogenyaxis[,3])/max(concinnum_kampung_torsion_curvature_ontogenyaxis[,3])
)

library(ggplot2)
(perimeter_standardised_ontogeny_axis  <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = log(shell_volume_list),size=I(1)))#,shape = shell_with_complete_spire[,4]))
perimeter_standardised_ontogeny_axis + scale_colour_gradientn(colours = rainbow(7))+ xlim(0,1) + ylim(0,6) #  scale_shape_manual(values=c(4,17))

(perimeter_ontogeny_axis_2  <- qplot(Final_data_output$ontogeny_axis,Final_data_output$perimeter, colour = log(shell_volume_list),size=I(1)))#,shape = shell_with_complete_spire[,4]))
perimeter_ontogeny_axis_2 + scale_colour_gradientn(colours = rainbow(7))+ xlim(0,25) + ylim(0,6) #  scale_shape_manual(values=c(4,17))


plot(standardised_ontogeny_axis,  
     (Final_data_output[,9]),
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)), 
     ylab =  "Aperture perimeter mm",
     #xaxt = "n",
     xlim=c(0,1.0),ylim = c(0,6)
)

shell_volume_list_outgrandi <- c(shell_volume_list,rep(7.664,660))
perimeter_outgrandi <- c(Final_data_output$perimeter,(Final_data_output$perimeter[7781:8440]))
standardised_ontogeny_axis_outgrandi <- c(standardised_ontogeny_axis,(standardised_ontogeny_axis[7781:8440])*1.40)
(perimeter_standardised_ontogeny_axis_outgrandi  <- qplot(standardised_ontogeny_axis_outgrandi ,perimeter_outgrandi, colour = log(shell_volume_list_outgrandi),size=I(1)))#,shape = shell_with_complete_spire[,4]))
perimeter_standardised_ontogeny_axis_outgrandi + scale_colour_gradientn(colours = rainbow(7))+ xlim(0,1.6) + ylim(0,6) #  scale_shape_manual(values=c(4,17))

##Shell aperture ontogeny profile raw curvature and torsion----
par(mar=c(2,2,1,1),mfcol=c(2, 2))
plot(standardised_ontogeny_axis,  
     (Final_data_output[,4]),
     #standardised_curvature,
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     ylab =  "curvature",
     xaxt= "n",
     xlim=c(0,1),ylim = c(0,4)#ylim = c(1.5,3)
)

plot(standardised_ontogeny_axis,  
     (Final_data_output[,9]),
     #standardised_curvature,
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     ylab =  "curvature",
     #xaxt= "n",
     xlim=c(0,1),ylim = c(0,4)#ylim = c(1.5,3)
)

plot(standardised_ontogeny_axis,  
     (Final_data_output[,5]),
     #standardised_torsion,
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     ylab =  "torsion",
     xaxt = "n",
     xlim=c(0,1),ylim = c(-6,2)#ylim = c(0,1)
)

plot(standardised_ontogeny_axis,  
     (Final_data_output[,6]),
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlab = "Standardised Ontogeny axis",ylab =  "Aperture shape score PC1",
     xlim=c(0,1.0),ylim = c(-0.2,0.2)
)

##Shell aperture ontogeny profile standardised curvature and torsion----
par(mar=c(2,2,1,1),mfcol=c(2, 1))
plot(standardised_ontogeny_axis,  
     #(Final_data_output[,4]),
     standardised_curvature,
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     ylab =  "curvature",
     # = "n",
     xlim=c(0,1),ylim = c(1.5,3)#ylim = c(0,4)
)

plot(standardised_ontogeny_axis,  
     #(Final_data_output[,5]),
     standardised_torsion,
     cex = 0.5,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     ylab =  "torsion",
     #xaxt = "n",
     xlim=c(0,1),ylim = c(0,1)#ylim = c(-6,2)
)

###Shell ontogenetic morphospace-----
(curvature_aperture_shape <- qplot(Final_data_output$PC1,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape + scale_colour_gradientn(colours = rainbow(7))+ xlim(-0.15,0.15) +ylim(1,4) #+ scale_shape_manual(values=c(4,17))

(torsion_aperture_shape <- qplot(Final_data_output$PC1,standardised_torsion, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
torsion_aperture_shape + scale_colour_gradientn(colours = rainbow(7)) + xlim(-0.15,0.15) + ylim(-12, 4) #+ scale_shape_manual(values=c(4,17))

(curvature_torsion <- qplot(standardised_torsion,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_torsion + scale_colour_gradientn(colours = rainbow(7)) + xlim(-12, 4) + ylim(-1,4) # scale_shape_manual(values=c(4,17))

pairwise_standardised_plots <- (cbind(standardised_curvature,standardised_torsion,Final_data_output$PC1))
colnames(pairwise_standardised_plots) <- c("standardised curvature","standardised torsion","aperture shape scores PC1")
pairs(pairwise_standardised_plots, 
      #col=Final_data_output$label, 
      col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)), 
      pch = 4, cex = 0.1)

par(mar=c(4,4,4,4),mfcol=c(2, 2))
plot(Final_data_output$PC1,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-0.15,0.15), ylim=c(1,4)
)

plot(Final_data_output$PC1,
     standardised_torsion,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-0.15,0.15), ylim=c(-12,4)
)

plot(standardised_torsion,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-12,4), ylim=c(1,4)
)



library(rgl)
plot3d(standardised_curvature, 
       standardised_torsion, 
       Final_data_output$PC1, 
       size=0.3, type='s',
       col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
       xlab = "standardised_curvature", ylab = "standardised_torsion", zlab = "Aperture shape")

### for appendix aperture ontogeny size standardised profile label with shell form------
## shell form data
apex_shape <- c(rep("2 - moderately convex", 760),
               rep("2 - moderately convex", 576),
               rep("3 - distinctly convex", 760),
               rep("2 - moderately convex", 952),
               rep("2 - moderately convex", 980),
               rep("2 - moderately convex", 992),
               rep("3 - distinctly convex", 856),
               rep("3 - distinctly convex", 968),
               rep("2 - moderately convex", 936),
               rep("2 - moderately convex", 660),
               rep("3 - distinctly convex", 963))

apical_spire_shape <- c(rep("2 - equilateral", 760),
                       rep("1 - depressed", 576),
                       rep("1 - depressed", 760),
                       rep("1 - depressed", 952),
                       rep("1 - depressed", 980),
                       rep("1 - depressed", 992),
                       rep("2 - equilateral", 856),
                       rep("2 - equilateral", 968),
                       rep("1 - depressed", 936),
                       rep("1 - depressed", 660),
                       rep("3 - oblong", 963))

basal_spire_shape <- c(rep("2 - ovoid", 760),
                      rep("2 - ovoid", 576),
                      rep("3 - conical", 760),
                      rep("1 - ellipsoid", 952),
                      rep("3 - conical", 980),
                      rep("2 - ovoid", 992),
                      rep("3 - conical", 856),
                      rep("2 - ovoid", 968),
                      rep("2 - ovoid", 936),
                      rep("2 - ovoid", 660),
                      rep("3 - conical", 963))

tuba_shape <- c(rep("1 - regular", 760),
               rep("2 - distort", 576),
               rep("3 - twist", 760),
               rep("1 - regular", 952),
               rep("3 - twist", 980),
               rep("3 - twist", 992),
               rep("1 - regular", 856),
               rep("2 - distort", 968),
               rep("3 - twist", 936),
               rep("3 - twist", 660),
               rep("3 - twist", 963))

aperture_view <- c(rep("2 - left", 760),
                   rep("2 - left", 576),
                   rep("4 - right", 760),
                   rep("3 - back", 952),
                   rep("4 - right", 980),
                   rep("3 - back", 992),
                   rep("2 - left", 856),
                   rep("2 - left", 968),
                   rep("1 - front", 936),
                   rep("2 - left", 660),
                   rep("2 - left", 963))
##
library(gridExtra)
(perimeter_apex <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = apex_shape,size=I(1), xlab = "standardised ontogeny axis (%)", ylab="aperture size (mm)"))
(standardised_curvature_apex <- qplot(standardised_ontogeny_axis,standardised_curvature, colour = apex_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised curvature (mm-1)"))
(standardised_torsion_apex <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = apex_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)"))
(shape_PC1_apex <- qplot(standardised_ontogeny_axis,Final_data_output$PC1, colour = apex_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="aperture shape scores"))
(zoom_in_standardised_torsion_apex <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = apex_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)", xlim = c(0,0.7), ylim = c(-0.5,1)))
grid.arrange(perimeter_apex,shape_PC1_apex,standardised_torsion_apex,standardised_curvature_apex,zoom_in_standardised_torsion_apex ,ncol=2)

(perimeter_apical_spire <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = apical_spire_shape,size=I(1), xlab = "standardised ontogeny axis (%)", ylab="aperture size (mm)"))
(standardised_curvature_apical_spire <- qplot(standardised_ontogeny_axis,standardised_curvature, colour = apical_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised curvature (mm-1)"))
(standardised_torsion_apical_spire <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = apical_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)"))
(shape_PC1_apical_spire <- qplot(standardised_ontogeny_axis,Final_data_output$PC1, colour = apical_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="aperture shape scores"))
(zoom_in_torsion_apical_spire <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = apical_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)", xlim = c(0,0.7), ylim = c(-1,1)))
grid.arrange(perimeter_apical_spire,shape_PC1_apical_spire,standardised_torsion_apical_spire,standardised_curvature_apical_spire,zoom_in_torsion_apical_spire,ncol=2)
  
(perimeter_basal_spire <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = basal_spire_shape,size=I(1), xlab = "standardised ontogeny axis (%)", ylab="aperture size (mm)"))
(standardised_curvature_basal_spire <- qplot(standardised_ontogeny_axis,standardised_curvature, colour = basal_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised curvature (mm-1)"))
(standardised_torsion_basal_spire <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = basal_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)"))
(shape_PC1_basal_spire <- qplot(standardised_ontogeny_axis,Final_data_output$PC1, colour = basal_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="aperture shape scores"))
(zoom_in_torsion_basal_spire <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = basal_spire_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)", xlim = c(0.6,0.9), ylim = c(-2.5,2.5)))
grid.arrange(perimeter_basal_spire,shape_PC1_basal_spire,standardised_torsion_basal_spire,standardised_curvature_basal_spire,zoom_in_torsion_basal_spire,ncol=2)

(perimeter_tuba <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = tuba_shape,size=I(1), xlab = "standardised ontogeny axis (%)", ylab="aperture size (mm)"))
(standardised_curvature_tuba <- qplot(standardised_ontogeny_axis,standardised_curvature, colour = tuba_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised curvature (mm-1)"))
(standardised_torsion_tuba <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = tuba_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)"))
(shape_PC1_tuba <- qplot(standardised_ontogeny_axis,Final_data_output$PC1, colour = tuba_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="aperture shape scores"))
(zoom_in_torsion_tuba <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = tuba_shape,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)", xlim = c(0.8,1), ylim = c(-12,3)))
grid.arrange(perimeter_tuba,shape_PC1_tuba,standardised_torsion_tuba,standardised_curvature_tuba,zoom_in_torsion_tuba,ncol=2)

(perimeter_aperture_view <- qplot(standardised_ontogeny_axis,Final_data_output$perimeter, colour = aperture_view,size=I(1), xlab = "standardised ontogeny axis (%)", ylab="aperture size (mm)"))
(standardised_curvature_aperture_view <- qplot(standardised_ontogeny_axis,standardised_curvature, colour = aperture_view,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised curvature (mm-1)"))
(standardised_torsion_aperture_view <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = aperture_view,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)"))
(shape_PC1_aperture_view <- qplot(standardised_ontogeny_axis,Final_data_output$PC1, colour = aperture_view,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="aperture shape scores"))
(zoom_in_torsion_aperture_view <- qplot(standardised_ontogeny_axis,standardised_torsion, colour = aperture_view,size=I(0.5), xlab = "standardised ontogeny axis (%)", ylab="standardised torsion (mm-1)", xlim = c(0.8,1), ylim = c(-12,3)))
grid.arrange(perimeter_aperture_view,shape_PC1_aperture_view,standardised_torsion_aperture_view,standardised_curvature_aperture_view,zoom_in_torsion_aperture_view ,ncol=2)

# whole morphospace and outlier
par(mar=c(3,3,1,1),mfcol=c(1, 6))
outliers_aperture_shape <- boxplot(Final_data_output$PC1,range=1.5)
outliers_standardised_torsion <- boxplot(standardised_torsion,range=1.5)
outliers_standardised_curvature <- boxplot(standardised_curvature,range=1.5)

(curvature_aperture_shape_outlier <- qplot(Final_data_output$PC1,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier<-curvature_aperture_shape_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE)+ 
  xlim(-0.15,0.15) +ylim(1,4) + 
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")#+ scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier

(torsion_aperture_shape_outlier <- qplot(standardised_torsion, Final_data_output$PC1,colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
torsion_aperture_shape_outlier<-torsion_aperture_shape_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE) +
  xlim(-12, 4) + ylim(-0.15,0.15) +
  geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))
torsion_aperture_shape_outlier

(curvature_torsion_outlier <- qplot(standardised_torsion,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier<-curvature_torsion_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(-12, 4) + ylim(1,4) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier

(curvature_aperture_shape_outlier_dummy <- qplot(Final_data_output$PC1,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_dummy<-curvature_aperture_shape_outlier_dummy + 
  scale_colour_gradientn(colours = rainbow(7))+ 
  xlim(-0.15,0.15) +ylim(1,4) + 
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")#+ scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier

grid.arrange(curvature_torsion_outlier,curvature_aperture_shape_outlier,torsion_aperture_shape_outlier,curvature_aperture_shape_outlier_dummy,ncol=2)

par(mar=c(3,3,1,1),mfcol=c(2, 2))
plot(standardised_torsion,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-12,4), ylim=c(1,4)
)
abline(v=outliers_standardised_torsion$stats[1], col="red", lty=2)
abline(v=outliers_standardised_torsion$stats[5], col="red", lty=2)
abline(h=outliers_standardised_curvature$stats[1], col="red", lty=2)
abline(h=outliers_standardised_curvature$stats[5], col="red", lty=2)

plot(standardised_torsion,
     Final_data_output$PC1,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-12,4), ylim=c(-0.15,0.15)
)
abline(v=outliers_standardised_torsion$stats[1], col="red", lty=2)
abline(v=outliers_standardised_torsion$stats[5], col="red", lty=2)
abline(h=outliers_aperture_shape$stats[1], col="red", lty=2)
abline(h=outliers_aperture_shape$stats[5], col="red", lty=2)

plot(Final_data_output$PC1,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(-0.15,0.15), ylim=c(1,4)
)
abline(h=outliers_standardised_curvature$stats[1], col="red", lty=2)
abline(h=outliers_standardised_curvature$stats[5], col="red", lty=2)
abline(v=outliers_aperture_shape$stats[1], col="red", lty=2)
abline(v=outliers_aperture_shape$stats[5], col="red", lty=2)

par(mar=c(3,3,1,1),mfcol=c(2, 2))
#par(mar=c(4,4,3,3),mfcol=c(1, 1))
plot(standardised_torsion,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(outliers_standardised_torsion$stats[1],outliers_standardised_torsion$stats[5]),
     ylim=c(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5])
)

plot(standardised_torsion,
     Final_data_output$PC1,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(outliers_standardised_torsion$stats[1],outliers_standardised_torsion$stats[5]),
     ylim=c(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5])
)

plot(Final_data_output$PC1,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]), 
     ylim=c(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5])
)



# portion of morphospace without outlier
(curvature_aperture_shape_outlier <- qplot(Final_data_output$PC1,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier<-curvature_aperture_shape_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE)+ 
  xlim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) +ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")#+ scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier

(torsion_aperture_shape_outlier <- qplot(standardised_torsion, Final_data_output$PC1,colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
torsion_aperture_shape_outlier<-torsion_aperture_shape_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE) +
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) 
  #geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))
torsion_aperture_shape_outlier

(curvature_torsion_outlier <- qplot(standardised_torsion,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier<-curvature_torsion_outlier + 
  scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier

#labelled with shell part shape
(curvature_torsion_outlier_apex <- qplot(standardised_torsion,standardised_curvature, colour = apex_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier_apex<-curvature_torsion_outlier_apex + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier_apex

(curvature_torsion_outlier_tuba <- qplot(standardised_torsion,standardised_curvature, colour = tuba_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier_tuba<-curvature_torsion_outlier_tuba + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier_tuba

(curvature_torsion_outlier_apical_spire <- qplot(standardised_torsion,standardised_curvature, colour = apical_spire_shape,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier_apical_spire<-curvature_torsion_outlier_apical_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5])
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier_apical_spire

(curvature_torsion_outlier_basal_spire <- qplot(standardised_torsion,standardised_curvature, colour = basal_spire_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier_basal_spire<-curvature_torsion_outlier_basal_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier_basal_spire

(curvature_torsion_outlier_standardised_ontogeny <- qplot(standardised_torsion,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_torsion_outlier_standardised_ontogeny<-curvature_torsion_outlier_standardised_ontogeny + 
  scale_colour_gradientn(colours = rainbow(7)) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) 
  #geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  #geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  #geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  #geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_torsion_outlier_standardised_ontogeny

species_<-plot(standardised_torsion,
     standardised_curvature,
     cex = 0.5, pch = 20,
     col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
     xlim=c(outliers_standardised_torsion$stats[1],outliers_standardised_torsion$stats[5]),
     ylim=c(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5])
)

grid.arrange(curvature_torsion_outlier_apex,curvature_torsion_outlier_apical_spire,curvature_torsion_outlier_tuba,curvature_torsion_outlier_basal_spire,ncol=2)

aperture_shape <- Final_data_output[,6]
(aperture_shape_torsion_outlier_apex <- qplot(standardised_torsion,aperture_shape, colour = apex_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
aperture_shape_torsion_outlier_apex<-aperture_shape_torsion_outlier_apex + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) +
  geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
aperture_shape_torsion_outlier_apex

(aperture_shape_torsion_outlier_tuba <- qplot(standardised_torsion,aperture_shape, colour = tuba_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
aperture_shape_torsion_outlier_tuba<-aperture_shape_torsion_outlier_tuba + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) +
  geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
aperture_shape_torsion_outlier_tuba

(aperture_shape_torsion_outlier_apical_spire <- qplot(standardised_torsion,aperture_shape, colour = apical_spire_shape,size=I(1)))#,shape = shell_with_complete_spire[,4]))
aperture_shape_torsion_outlier_apical_spire<-aperture_shape_torsion_outlier_apical_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) +
  geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
aperture_shape_torsion_outlier_apical_spire

(aperture_shape_torsion_outlier_basal_spire <- qplot(standardised_torsion,aperture_shape, colour = basal_spire_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
aperture_shape_torsion_outlier_basal_spire<-aperture_shape_torsion_outlier_basal_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_standardised_torsion$stats[1], outliers_standardised_torsion$stats[5]) + ylim(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]) +
  geom_hline(yintercept=outliers_aperture_shape$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_aperture_shape$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_standardised_torsion$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_standardised_torsion$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
aperture_shape_torsion_outlier_basal_spire


species_<-plot(standardised_torsion,
               aperture_shape,
               cex = 0.5, pch = 20,
               col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
               xlim=c(outliers_standardised_torsion$stats[1],outliers_standardised_torsion$stats[5]),
               ylim=c(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5])
)

grid.arrange(aperture_shape_torsion_outlier_apex,aperture_shape_torsion_outlier_apical_spire,aperture_shape_torsion_outlier_tuba,aperture_shape_torsion_outlier_basal_spire,ncol=2)

(curvature_aperture_shape_outlier_apex <- qplot(aperture_shape,standardised_curvature, colour = apex_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_apex<-curvature_aperture_shape_outlier_apex + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_aperture_shape$stats[1], outliers_aperture_shape$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier_apex

(curvature_aperture_shape_outlier_tuba <- qplot(aperture_shape,standardised_curvature, colour = tuba_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_tuba<-curvature_aperture_shape_outlier_tuba + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_aperture_shape$stats[1], outliers_aperture_shape$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier_tuba

(curvature_aperture_shape_outlier_apical_spire <- qplot(aperture_shape,standardised_curvature, colour = apical_spire_shape,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_apical_spire<-curvature_aperture_shape_outlier_apical_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_aperture_shape$stats[1], outliers_aperture_shape$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier_apical_spire

(curvature_aperture_shape_outlier_basal_spire <- qplot(aperture_shape,standardised_curvature, colour = basal_spire_shape,size=I(1)))#standardised_ontogeny_axis,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_basal_spire<-curvature_aperture_shape_outlier_basal_spire + 
  #scale_colour_gradientn(colours = rainbow(7),guide = FALSE) + 
  xlim(outliers_aperture_shape$stats[1], outliers_aperture_shape$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier_basal_spire

(curvature_aperture_shape_outlier_standardised_ontogeny <- qplot(aperture_shape,standardised_curvature, colour = standardised_ontogeny_axis,size=I(1)))#,shape = shell_with_complete_spire[,4]))
curvature_aperture_shape_outlier_standardised_ontogeny<-curvature_aperture_shape_outlier_standardised_ontogeny + 
  scale_colour_gradientn(colours = rainbow(7)) + 
  xlim(outliers_aperture_shape$stats[1], outliers_aperture_shape$stats[5]) + ylim(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5]) +
  geom_hline(yintercept=outliers_standardised_curvature$stats[1],linetype = "longdash") +
  geom_hline(yintercept=outliers_standardised_curvature$stats[5],linetype = "longdash") +
  geom_vline(xintercept=outliers_aperture_shape$stats[1],linetype = "longdash") + 
  geom_vline(xintercept=outliers_aperture_shape$stats[5],linetype = "longdash")  #+ scale_shape_manual(values=c(4,17))# scale_shape_manual(values=c(4,17))
curvature_aperture_shape_outlier_standardised_ontogeny

species_<-plot(aperture_shape,
               standardised_curvature,
               cex = 0.5, pch = 20,
               col=c(rep("red",760),rep("yellow",576), rep("blue",760), rep("dodgerblue",952), rep("darkgreen",980),rep("black",992),rep("grey",856),rep("purple",968), rep("green",936), rep("darkorange",660), rep("darkred",963)),
               xlim=c(outliers_aperture_shape$stats[1],outliers_aperture_shape$stats[5]),
               ylim=c(outliers_standardised_curvature$stats[1],outliers_standardised_curvature$stats[5])
)

grid.arrange(curvature_aperture_shape_outlier_apex,curvature_aperture_shape_outlier_apical_spire,curvature_aperture_shape_outlier_tuba,curvature_aperture_shape_outlier_basal_spire,ncol=2)

############example tutorial -----

setwd("C:/Users/User/Downloads/continuous.tutorial/continuous.tutorial/")

#### Data Preparation
require(geiger)
require(phytools)
require(devtools)
require(nlme)
require(qpcR)
require(reshape)
require(calibrate)


tree_file <- read.tree("GA_AnolisMCC.tre")
tree_file
plot(tree_file,cex=0.5)

ecomorpho_char <- read.csv("anole_limbs_ecol.csv", row.names=1)

taxa_only_in_tree <- setdiff(tree_file$tip.label,rownames(ecomorpho_char))
taxa_only_in_tree

taxa_only_in_char <- setdiff(rownames(ecomorpho_char),tree_file$tip.label)
taxa_only_in_char

tree_after_removed_taxa_without_char <- drop.tip(tree_file,taxa_only_in_tree)
tree_after_removed_taxa_without_char

char_after_removed_taxa_not_in_tree <- ecomorpho_char[-match(taxa_only_in_char,rownames(ecomorpho_char)),]
char_after_removed_taxa_not_in_tree 

sorted_ecomorpho_char_according_tree_order <- ecomorpho_char[tree_after_removed_taxa_without_char$tip.label,]

sorted_ecomorpho_char_limb <- sorted_ecomorpho_char_according_tree_order[,1]
names(sorted_ecomorpho_char_limb) <- row.names(ecomorpho_char)
sorted_ecomorpho_char_perch <- sorted_ecomorpho_char_according_tree_order[,2]
names(sorted_ecomorpho_char_perch) <- row.names(ecomorpho_char)
sorted_ecomorpho_char_habitat <- sorted_ecomorpho_char_according_tree_order[,3]
names(sorted_ecomorpho_char_habitat) <- row.names(ecomorpho_char)

#### Data exploration
stardardised_limb_0_1 <- (sorted_ecomorpho_char_limb-min(sorted_ecomorpho_char_limb))/(max(sorted_ecomorpho_char_limb)-min(sorted_ecomorpho_char_limb))
stardardised_perch_0_1 <- (sorted_ecomorpho_char_perch-min(sorted_ecomorpho_char_perch))/(max(sorted_ecomorpho_char_perch)-min(sorted_ecomorpho_char_perch))

plot(tree_after_removed_taxa_without_char, x.lim=3, cex=0.5, font=4, label.offset=0.025, edge.width=3)

number_of_taxa <- length(tree_after_removed_taxa_without_char$tip.label)


mtext("relative perch diameter", at=1.6, side=1, line=0, font=2, cex=0.5)

segments(rep(2,number_of_taxa),1:number_of_taxa,rep(2,number_of_taxa)+(0.3*stardardised_limb_0_1),1:number_of_taxa,lwd=3)
mtext("relative limb length", at=2.2, side=1, line=0, font=2, cex=0.5)

limbs.lambda <- phylosig(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_limb,method="lambda")
limbs.K <- phylosig(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_limb,method="K", nsim=1000)

perch.lambda <- phylosig(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_perch,method="lambda")
perch.K <- phylosig(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_perch,method="K", nsim=1000)

limbs.lambda
limbs.K
perch.lambda
perch.K

#####Ancestral state estimation for continuous traits 
#(plus phylomorphospace plotting)
limbs.ancestral <- fastAnc(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_limb, CI=TRUE)
perch.ancestral <- fastAnc(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_perch, CI=TRUE)

parsettings <- par(no.readonly=TRUE) # record plotting parameters
par(mfrow=c(1,2)) # Set plotting parameters to make 2 panel plot
contMap(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_limb, res=30, fsize=c(1,0.6))
contMap(tree_after_removed_taxa_without_char,sorted_ecomorpho_char_perch, res=30, fsize=c(1,0.6))
par(parsettings)

#par(mar=c(4,4, 4, 4),mfrow=c(1,1))
plot(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb, xlim=c(-3,5), ylim=c(-10,5), xlab="Perch", ylab="limb", pch=19, col="red")

phylomorphospace(tree=tree_after_removed_taxa_without_char, X=cbind(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb), 
                 label="horizontal", xlim=c(-3,5), ylim=c(-8.5,4.5),
                 xlab="perch", ylab="limb")

tip.cols <- rep("red",number_of_taxa)
node.cols <- rep("black",tree_after_removed_taxa_without_char$Nnode)
cols <- c(tip.cols,node.cols)
names(cols) <- 1:length(cols)
phylomorphospace(tree=tree_after_removed_taxa_without_char, X=cbind(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb), 
                 label="horizontal", xlim=c(-3,5), ylim=c(-8.5,4.5),
                 xlab="perch", ylab="limb", control=list(col.node=cols))

#####Testing for an ecomorphological relationship
###### in anoles using phylogenetic regression
plot(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb, xlim=c(-3,5), ylim=c(-10,5), xlab="Perch", ylab="limb", pch=19, col="red")

regression_limb_perch <- lm(sorted_ecomorpho_char_limb~sorted_ecomorpho_char_perch)
summary(regression_limb_perch)
plot(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb, xlim=c(-3,5), ylim=c(-10,5), xlab="Perch", ylab="limb", pch=19, col="red")
abline(regression_limb_perch)
abline(0,1,lty="dotted")

phylogenetic_independent_contrast_perch <- pic(sorted_ecomorpho_char_perch,tree_after_removed_taxa_without_char)
phylogenetic_independent_contrast_limb<- pic(sorted_ecomorpho_char_limb,tree_after_removed_taxa_without_char)

plot(phylogenetic_independent_contrast_perch,phylogenetic_independent_contrast_limb, xlab="PIC_Perch", ylab="PIC_limb", pch=19, col="blue")

phylogenetic_independent_contrast_model <- lm(phylogenetic_independent_contrast_limb~phylogenetic_independent_contrast_perch -1)
summary(phylogenetic_independent_contrast_model)
abline(phylogenetic_independent_contrast_model)



correlation_Pure_Brownian <- gls(PCI_limbs~logPD, data=ecomorpho_char, correlation=corBrownian(phy=tree_after_removed_taxa_without_char), method="ML")
summary(correlation_Pure_Brownian)
plot(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb, xlim=c(-3,5), ylim=c(-10,5), xlab="Perch", ylab="limb", pch=19, col="green")
abline(correlation_Pure_Brownian, col="green")
abline(regression_limb_perch)


correlation_lambda <- gls(PCI_limbs~logPD, data=ecomorpho_char, correlation=corPagel(value=1, phy=tree_after_removed_taxa_without_char, fixed=FALSE), method="ML")
summary(correlation_lambda)
plot(sorted_ecomorpho_char_perch,sorted_ecomorpho_char_limb, xlim=c(-3,5), ylim=c(-10,5), xlab="Perch", ylab="limb", pch=19, col="green")
abline(correlation_Pure_Brownian, col="green")
abline(regression_limb_perch)

###Geiger
limbs <- read.csv("Limbs.csv",row.names=1)
sorted_limbs <- limbs[tree_file$tip.label,,drop=FALSE]

brownian_morphological_drift_model_limbs <- fitContinuous(tree_file,sorted_limbs, model="BM")
early_burst_adapative_radiation_model_limbs <- fitContinuous(tree_file,sorted_limbs, model="EB", bounds=list(a=c(-3,1)))
ornstein_evolutionary_constraint_model_limbs <- fitContinuous(tree_file,sorted_limbs,model="OU")

brownian_morphological_drift_model_limbs$opt$lnL
early_burst_adapative_radiation_model_limbs$opt$lnL
ornstein_evolutionary_constraint_model_limbs$opt$lnL


model_comparison_BM_EB_OU <- matrix(,3,4,dimnames = list(c("Brownian Motion", "Early Burst", "Ornstein-Uhlenbeck"),c("log likelihood", "AICc", "Delta AICc", "AICc Weights")))
model_comparison_BM_EB_OU[,1] <-c(brownian_morphological_drift_model_limbs$opt$lnL, early_burst_adapative_radiation_model_limbs$opt$lnL, ornstein_evolutionary_constraint_model_limbs$opt$lnL)
model_comparison_BM_EB_OU[,2] <-c(brownian_morphological_drift_model_limbs$opt$aicc, early_burst_adapative_radiation_model_limbs$opt$aicc, ornstein_evolutionary_constraint_model_limbs$opt$aicc)

aic.all <- as.matrix(model_comparison_BM_EB_OU[,2])
aic_score_weight <- akaike.weights(aic.all)

model_comparison_BM_EB_OU[,3] <- aic_score_weight$deltaAIC
model_comparison_BM_EB_OU[,4] <- aic_score_weight$weights

model_comparison_BM_EB_OU


##
library(geiger)
## match data and tree
tmp=get(data(geospiza))
td=treedata(tmp$phy, tmp$dat)
geo=list(phy=td$phy, dat=td$data)
gb=round(geo$dat[,5]) ## create discrete data
names(gb)=rownames(geo$dat)
mm=rbind(c(NA, 0, 0), c(1, NA, 2), c(0, 2, NA))
fitDiscrete(geo$phy, gb, model="ER", control=list(niter=5)) #-7.119792
fitDiscrete(geo$phy, gb, model="ARD") #-6.064573
fitDiscrete(geo$phy, gb, model=mm) #-7.037944
fitDiscrete(geo$phy, gb, model="SYM", transshape="kappa") #-6.822943


###geostat------
library(gstat)